require "Dieta"


#Estructura usada como nodo para la lista doblemente enlazada.
Node = Struct.new(:value, :next,:previous)

#Clase que implementa una lista enlazada
class ListaEnlazada

    attr_reader :size, :top, :bottom
    include Enumerable

#Al inicializarse el objeto. El tamaño de la lista es cero y tanto @bottom como @top son nil.
    def initialize
      @bottom = nil
      @top = nil
      @size = 0
    end

#Añade un elemento al final de la lista. @top apuntará al último elemento añadido
    def push (element)
        aux = @top
        @top = Node.new(element, nil ,@top)
        if (aux!=nil)
          aux.next = @top
        end
        if (@bottom != nil && @bottom.next == nil )
          @bottom.next = @top
        end
        if @bottom == nil
          @bottom = @top
        end
        @size += 1
      end

#Elimina el último elemento añadido a la lista. En este caso, @top apuntará al elemento anterior.
      def pop
        if @top==nil
          output = "Error. La lista está vacía."
        else
          @top = @top.previous
          if @top == nil
            @bottom = nil
          end
          @size -= 1
        end
      end

      def each
        i = bottom
        while i!=nil do
          yield i.value
          i = i.next;
        end
      end


#Método que permite mostrar el último elemento añadido en la lista. En caso de que la lista esté vacía, mostrará el mensaje "Error. La lista está vacía"
    def to_s
      if @top==nil
        output = "Error. La lista está vacía."
      else
        @top.value.to_s
      end
    end

end
